#ifndef MSP_GLTK_LABEL_H_
#define MSP_GLTK_LABEL_H_

#include "text.h"
#include "widget.h"

namespace Msp {
namespace GLtk {

/**
Labels display static text.  There is one special part: "text".
*/
class Label: public Widget
{
public:
	class Loader: public DataFile::DerivedObjectLoader<Label, Widget::Loader>
	{
	public:
		Loader(Label &);
	private:
		void text(const std::string &);
	};

private:
	Text text;

public:
	Label(const std::string & = std::string());

	virtual const char *get_class() const { return "label"; }

	virtual void autosize();
	void set_text(const std::string &);

private:
	virtual void rebuild_special(const Part &);

	virtual void on_style_change();
};

} // namespace GLtk
} // namespace Msp

#endif
